## PhoshIdleDBusObjectManagerClient

PhoshIdleDBusObjectManagerClient

## Functions

GDBusInterfaceInfo * | phosh_idle_dbus_idle_monitor_interface_info ()
guint | phosh_idle_dbus_idle_monitor_override_properties ()
void | phosh_idle_dbus_idle_monitor_complete_get_idletime ()
void | phosh_idle_dbus_idle_monitor_complete_add_idle_watch ()
void | phosh_idle_dbus_idle_monitor_complete_add_user_active_watch ()
void | phosh_idle_dbus_idle_monitor_complete_remove_watch ()
void | phosh_idle_dbus_idle_monitor_emit_watch_fired ()
void | phosh_idle_dbus_idle_monitor_call_get_idletime ()
gboolean | phosh_idle_dbus_idle_monitor_call_get_idletime_finish ()
gboolean | phosh_idle_dbus_idle_monitor_call_get_idletime_sync ()
void | phosh_idle_dbus_idle_monitor_call_add_idle_watch ()
gboolean | phosh_idle_dbus_idle_monitor_call_add_idle_watch_finish ()
gboolean | phosh_idle_dbus_idle_monitor_call_add_idle_watch_sync ()
void | phosh_idle_dbus_idle_monitor_call_add_user_active_watch ()
gboolean | phosh_idle_dbus_idle_monitor_call_add_user_active_watch_finish ()
gboolean | phosh_idle_dbus_idle_monitor_call_add_user_active_watch_sync ()
void | phosh_idle_dbus_idle_monitor_call_remove_watch ()
gboolean | phosh_idle_dbus_idle_monitor_call_remove_watch_finish ()
gboolean | phosh_idle_dbus_idle_monitor_call_remove_watch_sync ()
void | phosh_idle_dbus_idle_monitor_proxy_new ()
PhoshIdleDBusIdleMonitor * | phosh_idle_dbus_idle_monitor_proxy_new_finish ()
PhoshIdleDBusIdleMonitor * | phosh_idle_dbus_idle_monitor_proxy_new_sync ()
void | phosh_idle_dbus_idle_monitor_proxy_new_for_bus ()
PhoshIdleDBusIdleMonitor * | phosh_idle_dbus_idle_monitor_proxy_new_for_bus_finish ()
PhoshIdleDBusIdleMonitor * | phosh_idle_dbus_idle_monitor_proxy_new_for_bus_sync ()
PhoshIdleDBusIdleMonitor * | phosh_idle_dbus_idle_monitor_skeleton_new ()
PhoshIdleDBusIdleMonitor * | phosh_idle_dbus_object_get_idle_monitor ()
PhoshIdleDBusIdleMonitor * | phosh_idle_dbus_object_peek_idle_monitor ()
PhoshIdleDBusObjectProxy * | phosh_idle_dbus_object_proxy_new ()
PhoshIdleDBusObjectSkeleton * | phosh_idle_dbus_object_skeleton_new ()
void | phosh_idle_dbus_object_skeleton_set_idle_monitor ()
GType | phosh_idle_dbus_object_manager_client_get_proxy_type ()
void | phosh_idle_dbus_object_manager_client_new ()
GDBusObjectManager * | phosh_idle_dbus_object_manager_client_new_finish ()
GDBusObjectManager * | phosh_idle_dbus_object_manager_client_new_sync ()
void | phosh_idle_dbus_object_manager_client_new_for_bus ()
GDBusObjectManager * | phosh_idle_dbus_object_manager_client_new_for_bus_finish ()
GDBusObjectManager * | phosh_idle_dbus_object_manager_client_new_for_bus_sync ()

## Properties

PhoshIdleDBusIdleMonitor * | idle-monitor | Read / Write

## Signals

gboolean | handle-add-idle-watch | Run Last
gboolean | handle-add-user-active-watch | Run Last
gboolean | handle-get-idletime | Run Last
gboolean | handle-remove-watch | Run Last
void | watch-fired | Run Last

## Types and Values

struct | PhoshIdleDBusIdleMonitorIface
struct | PhoshIdleDBusIdleMonitorProxy
struct | PhoshIdleDBusIdleMonitorProxyClass
struct | PhoshIdleDBusIdleMonitorSkeleton
struct | PhoshIdleDBusIdleMonitorSkeletonClass
struct | PhoshIdleDBusObjectIface
struct | PhoshIdleDBusObjectProxy
struct | PhoshIdleDBusObjectProxyClass
struct | PhoshIdleDBusObjectSkeleton
struct | PhoshIdleDBusObjectSkeletonClass
struct | PhoshIdleDBusObjectManagerClient
struct | PhoshIdleDBusObjectManagerClientClass
| PhoshIdleDBusIdleMonitor
| PhoshIdleDBusIdleMonitorProxyPrivate
| PhoshIdleDBusIdleMonitorSkeletonPrivate
| PhoshIdleDBusObject
| PhoshIdleDBusObjectManagerClientPrivate
| PhoshIdleDBusObjectProxyPrivate
| PhoshIdleDBusObjectSkeletonPrivate

## Object Hierarchy

        GInterface
        ├── PhoshIdleDBusIdleMonitor
        ╰── PhoshIdleDBusObject
        GObject
        ├── GDBusInterfaceSkeleton
        │   ╰── PhoshIdleDBusIdleMonitorSkeleton
        ├── GDBusObjectManagerClient
        │   ╰── PhoshIdleDBusObjectManagerClient
        ├── GDBusObjectProxy
        │   ╰── PhoshIdleDBusObjectProxy
        ├── GDBusObjectSkeleton
        │   ╰── PhoshIdleDBusObjectSkeleton
        ╰── GDBusProxy
            ╰── PhoshIdleDBusIdleMonitorProxy

## Prerequisites

PhoshIdleDBusIdleMonitor requires GObject.

PhoshIdleDBusObject requires GDBusObject and GObject.

## Implemented Interfaces

PhoshIdleDBusIdleMonitorProxy implements GDBusInterface, GInitable, GAsyncInitable and PhoshIdleDBusIdleMonitor.

PhoshIdleDBusIdleMonitorSkeleton implements GDBusInterface and PhoshIdleDBusIdleMonitor.

PhoshIdleDBusObjectProxy implements GDBusObject and PhoshIdleDBusObject.

PhoshIdleDBusObjectSkeleton implements GDBusObject and PhoshIdleDBusObject.

PhoshIdleDBusObjectManagerClient implements GInitable, GAsyncInitable and GDBusObjectManager.

## Known Implementations

PhoshIdleDBusIdleMonitor is implemented by PhoshIdleDBusIdleMonitorProxy and PhoshIdleDBusIdleMonitorSkeleton.

PhoshIdleDBusObject is implemented by PhoshIdleDBusObjectProxy and PhoshIdleDBusObjectSkeleton.

## Description

## Functions

### phosh_idle_dbus_idle_monitor_interface_info ()

    GDBusInterfaceInfo *
    phosh_idle_dbus_idle_monitor_interface_info
                                   (void);

Gets a machine-readable description of the org.gnome.Mutter.IdleMonitor D-Bus interface.

#### Returns

A GDBusInterfaceInfo. Do not free.

[transfer none]

### phosh_idle_dbus_idle_monitor_override_properties ()

    guint
    phosh_idle_dbus_idle_monitor_override_properties
                                   (GObjectClass *klass,
                                    guint property_id_begin);

Overrides all GObject properties in the PhoshIdleDBusIdleMonitor interface for a concrete class. The properties are overridden in the order they are defined.

#### Parameters

klass | The class structure for a GObject derived class. |
property_id_begin | The property id to assign to the first overridden property. |

#### Returns

The last property id.

### phosh_idle_dbus_idle_monitor_complete_get_idletime ()

    void
    phosh_idle_dbus_idle_monitor_complete_get_idletime
                                   (PhoshIdleDBusIdleMonitor *object,
                                    GDBusMethodInvocation *invocation,
                                    guint64 idletime);

Helper function used in service implementations to finish handling invocations of the `GetIdletime()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A PhoshIdleDBusIdleMonitor. |
invocation | A GDBusMethodInvocation. | [transfer full]
idletime | Parameter to return. |

### phosh_idle_dbus_idle_monitor_complete_add_idle_watch ()

    void
    phosh_idle_dbus_idle_monitor_complete_add_idle_watch
                                   (PhoshIdleDBusIdleMonitor *object,
                                    GDBusMethodInvocation *invocation,
                                    guint id);

Helper function used in service implementations to finish handling invocations of the `AddIdleWatch()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A PhoshIdleDBusIdleMonitor. |
invocation | A GDBusMethodInvocation. | [transfer full]
id | Parameter to return. |

### phosh_idle_dbus_idle_monitor_complete_add_user_active_watch ()

    void
    phosh_idle_dbus_idle_monitor_complete_add_user_active_watch
                                   (PhoshIdleDBusIdleMonitor *object,
                                    GDBusMethodInvocation *invocation,
                                    guint id);

Helper function used in service implementations to finish handling invocations of the `AddUserActiveWatch()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A PhoshIdleDBusIdleMonitor. |
invocation | A GDBusMethodInvocation. | [transfer full]
id | Parameter to return. |

### phosh_idle_dbus_idle_monitor_complete_remove_watch ()

    void
    phosh_idle_dbus_idle_monitor_complete_remove_watch
                                   (PhoshIdleDBusIdleMonitor *object,
                                    GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `RemoveWatch()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A PhoshIdleDBusIdleMonitor. |
invocation | A GDBusMethodInvocation. | [transfer full]

### phosh_idle_dbus_idle_monitor_emit_watch_fired ()

    void
    phosh_idle_dbus_idle_monitor_emit_watch_fired
                                   (PhoshIdleDBusIdleMonitor *object,
                                    guint arg_id);

Emits the "WatchFired" D-Bus signal.

#### Parameters

object | A PhoshIdleDBusIdleMonitor. |
arg_id | Argument to pass with the signal. |

### phosh_idle_dbus_idle_monitor_call_get_idletime ()

    void
    phosh_idle_dbus_idle_monitor_call_get_idletime
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `GetIdletime()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_idle_dbus_idle_monitor_call_get_idletime_finish()` to get the result of the operation.

See `phosh_idle_dbus_idle_monitor_call_get_idletime_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### phosh_idle_dbus_idle_monitor_call_get_idletime_finish ()

    gboolean
    phosh_idle_dbus_idle_monitor_call_get_idletime_finish
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    guint64 *out_idletime,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_idle_dbus_idle_monitor_call_get_idletime()`.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
out_idletime | Return location for return parameter or `NULL` to ignore. | [out][optional]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_idle_dbus_idle_monitor_call_get_idletime()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_idle_dbus_idle_monitor_call_get_idletime_sync ()

    gboolean
    phosh_idle_dbus_idle_monitor_call_get_idletime_sync
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    guint64 *out_idletime,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `GetIdletime()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `phosh_idle_dbus_idle_monitor_call_get_idletime()` for the asynchronous version of this method.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
out_idletime | Return location for return parameter or `NULL` to ignore. | [out][optional]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_idle_dbus_idle_monitor_call_add_idle_watch ()

    void
    phosh_idle_dbus_idle_monitor_call_add_idle_watch
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    guint64 arg_interval,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `AddIdleWatch()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_idle_dbus_idle_monitor_call_add_idle_watch_finish()` to get the result of the operation.

See `phosh_idle_dbus_idle_monitor_call_add_idle_watch_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
arg_interval | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### phosh_idle_dbus_idle_monitor_call_add_idle_watch_finish ()

    gboolean
    phosh_idle_dbus_idle_monitor_call_add_idle_watch_finish
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    guint *out_id,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_idle_dbus_idle_monitor_call_add_idle_watch()`.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
out_id | Return location for return parameter or `NULL` to ignore. | [out][optional]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_idle_dbus_idle_monitor_call_add_idle_watch()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_idle_dbus_idle_monitor_call_add_idle_watch_sync ()

    gboolean
    phosh_idle_dbus_idle_monitor_call_add_idle_watch_sync
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    guint64 arg_interval,
                                    guint *out_id,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `AddIdleWatch()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `phosh_idle_dbus_idle_monitor_call_add_idle_watch()` for the asynchronous version of this method.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
arg_interval | Argument to pass with the method invocation. |
out_id | Return location for return parameter or `NULL` to ignore. | [out][optional]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_idle_dbus_idle_monitor_call_add_user_active_watch ()

    void
    phosh_idle_dbus_idle_monitor_call_add_user_active_watch
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `AddUserActiveWatch()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_idle_dbus_idle_monitor_call_add_user_active_watch_finish()` to get the result of the operation.

See `phosh_idle_dbus_idle_monitor_call_add_user_active_watch_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### phosh_idle_dbus_idle_monitor_call_add_user_active_watch_finish ()

    gboolean
    phosh_idle_dbus_idle_monitor_call_add_user_active_watch_finish
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    guint *out_id,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_idle_dbus_idle_monitor_call_add_user_active_watch()`.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
out_id | Return location for return parameter or `NULL` to ignore. | [out][optional]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_idle_dbus_idle_monitor_call_add_user_active_watch()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_idle_dbus_idle_monitor_call_add_user_active_watch_sync ()

    gboolean
    phosh_idle_dbus_idle_monitor_call_add_user_active_watch_sync
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    guint *out_id,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `AddUserActiveWatch()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `phosh_idle_dbus_idle_monitor_call_add_user_active_watch()` for the asynchronous version of this method.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
out_id | Return location for return parameter or `NULL` to ignore. | [out][optional]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_idle_dbus_idle_monitor_call_remove_watch ()

    void
    phosh_idle_dbus_idle_monitor_call_remove_watch
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    guint arg_id,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `RemoveWatch()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_idle_dbus_idle_monitor_call_remove_watch_finish()` to get the result of the operation.

See `phosh_idle_dbus_idle_monitor_call_remove_watch_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
arg_id | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### phosh_idle_dbus_idle_monitor_call_remove_watch_finish ()

    gboolean
    phosh_idle_dbus_idle_monitor_call_remove_watch_finish
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_idle_dbus_idle_monitor_call_remove_watch()`.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_idle_dbus_idle_monitor_call_remove_watch()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_idle_dbus_idle_monitor_call_remove_watch_sync ()

    gboolean
    phosh_idle_dbus_idle_monitor_call_remove_watch_sync
                                   (PhoshIdleDBusIdleMonitor *proxy,
                                    guint arg_id,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `RemoveWatch()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `phosh_idle_dbus_idle_monitor_call_remove_watch()` for the asynchronous version of this method.

#### Parameters

proxy | A PhoshIdleDBusIdleMonitorProxy. |
arg_id | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### phosh_idle_dbus_idle_monitor_proxy_new ()

    void
    phosh_idle_dbus_idle_monitor_proxy_new
                                   (GDBusConnection *connection,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously creates a proxy for the D-Bus interface org.gnome.Mutter.IdleMonitor. See `g_dbus_proxy_new()` for more details.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_idle_dbus_idle_monitor_proxy_new_finish()` to get the result of the operation.

See `phosh_idle_dbus_idle_monitor_proxy_new_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### phosh_idle_dbus_idle_monitor_proxy_new_finish ()

    PhoshIdleDBusIdleMonitor *
    phosh_idle_dbus_idle_monitor_proxy_new_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_idle_dbus_idle_monitor_proxy_new()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_idle_dbus_idle_monitor_proxy_new()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type PhoshIdleDBusIdleMonitorProxy]

### phosh_idle_dbus_idle_monitor_proxy_new_sync ()

    PhoshIdleDBusIdleMonitor *
    phosh_idle_dbus_idle_monitor_proxy_new_sync
                                   (GDBusConnection *connection,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously creates a proxy for the D-Bus interface org.gnome.Mutter.IdleMonitor. See `g_dbus_proxy_new_sync()` for more details.

The calling thread is blocked until a reply is received.

See `phosh_idle_dbus_idle_monitor_proxy_new()` for the asynchronous version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type PhoshIdleDBusIdleMonitorProxy]

### phosh_idle_dbus_idle_monitor_proxy_new_for_bus ()

    void
    phosh_idle_dbus_idle_monitor_proxy_new_for_bus
                                   (GBusType bus_type,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Like `phosh_idle_dbus_idle_monitor_proxy_new()` but takes a GBusType instead of a GDBusConnection.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_idle_dbus_idle_monitor_proxy_new_for_bus_finish()` to get the result of the operation.

See `phosh_idle_dbus_idle_monitor_proxy_new_for_bus_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### phosh_idle_dbus_idle_monitor_proxy_new_for_bus_finish ()

    PhoshIdleDBusIdleMonitor *
    phosh_idle_dbus_idle_monitor_proxy_new_for_bus_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_idle_dbus_idle_monitor_proxy_new_for_bus()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_idle_dbus_idle_monitor_proxy_new_for_bus()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type PhoshIdleDBusIdleMonitorProxy]

### phosh_idle_dbus_idle_monitor_proxy_new_for_bus_sync ()

    PhoshIdleDBusIdleMonitor *
    phosh_idle_dbus_idle_monitor_proxy_new_for_bus_sync
                                   (GBusType bus_type,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Like `phosh_idle_dbus_idle_monitor_proxy_new_sync()` but takes a GBusType instead of a GDBusConnection.

The calling thread is blocked until a reply is received.

See `phosh_idle_dbus_idle_monitor_proxy_new_for_bus()` for the asynchronous version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type PhoshIdleDBusIdleMonitorProxy]

### phosh_idle_dbus_idle_monitor_skeleton_new ()

    PhoshIdleDBusIdleMonitor *
    phosh_idle_dbus_idle_monitor_skeleton_new
                                   (void);

Creates a skeleton object for the D-Bus interface org.gnome.Mutter.IdleMonitor.

#### Returns

The skeleton object.

[transfer full][type PhoshIdleDBusIdleMonitorSkeleton]

### phosh_idle_dbus_object_get_idle_monitor ()

    PhoshIdleDBusIdleMonitor *
    phosh_idle_dbus_object_get_idle_monitor
                                   (PhoshIdleDBusObject *object);

Gets the PhoshIdleDBusIdleMonitor instance for the D-Bus interface org.gnome.Mutter.IdleMonitor on `object` , if any.

#### Parameters

object | A PhoshIdleDBusObject. |

#### Returns

A PhoshIdleDBusIdleMonitor that must be freed with `g_object_unref()` or `NULL` if `object` does not implement the interface.

[transfer full][nullable]

### phosh_idle_dbus_object_peek_idle_monitor ()

    PhoshIdleDBusIdleMonitor *
    phosh_idle_dbus_object_peek_idle_monitor
                                   (PhoshIdleDBusObject *object);

Like `phosh_idle_dbus_object_get_idle_monitor()` but doesn't increase the reference count on the returned object.

It is not safe to use the returned object if you are on another thread than the one where the GDBusObjectManagerClient or GDBusObjectManagerServer for `object` is running.

[skip]

#### Parameters

object | A PhoshIdleDBusObject. |

#### Returns

A PhoshIdleDBusIdleMonitor or `NULL` if `object` does not implement the interface. Do not free the returned object, it is owned by `object` .

[transfer none][nullable]

### phosh_idle_dbus_object_proxy_new ()

    PhoshIdleDBusObjectProxy *
    phosh_idle_dbus_object_proxy_new (GDBusConnection *connection,
                                      const gchar *object_path);

Creates a new proxy object.

#### Parameters

connection | A GDBusConnection. |
object_path | An object path. |

#### Returns

The proxy object.

[transfer full]

### phosh_idle_dbus_object_skeleton_new ()

    PhoshIdleDBusObjectSkeleton *
    phosh_idle_dbus_object_skeleton_new (const gchar *object_path);

Creates a new skeleton object.

#### Parameters

object_path | An object path. |

#### Returns

The skeleton object.

[transfer full]

### phosh_idle_dbus_object_skeleton_set_idle_monitor ()

    void
    phosh_idle_dbus_object_skeleton_set_idle_monitor
                                   (PhoshIdleDBusObjectSkeleton *object,
                                    PhoshIdleDBusIdleMonitor *interface_);

Sets the PhoshIdleDBusIdleMonitor instance for the D-Bus interface org.gnome.Mutter.IdleMonitor on `object` .

#### Parameters

object | A PhoshIdleDBusObjectSkeleton. |
interface_ | A PhoshIdleDBusIdleMonitor or `NULL` to clear the interface. | [nullable]

### phosh_idle_dbus_object_manager_client_get_proxy_type ()

    GType
    phosh_idle_dbus_object_manager_client_get_proxy_type
                                   (GDBusObjectManagerClient *manager,
                                    const gchar *object_path,
                                    const gchar *interface_name,
                                    gpointer user_data);

A GDBusProxyTypeFunc that maps `interface_name` to the generated GDBusObjectProxy derived and GDBusProxy derived types.

#### Parameters

manager | A GDBusObjectManagerClient. |
object_path | The object path of the remote object (unused). |
interface_name | Interface name of the remote object or `NULL` to get the object proxy GType. | [nullable]
user_data | User data (unused). |

#### Returns

A GDBusProxy derived GType if `interface_name` is not `NULL`, otherwise the GType for PhoshIdleDBusObjectProxy.

### phosh_idle_dbus_object_manager_client_new ()

    void
    phosh_idle_dbus_object_manager_client_new
                                   (GDBusConnection *connection,
                                    GDBusObjectManagerClientFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously creates GDBusObjectManagerClient using `phosh_idle_dbus_object_manager_client_get_proxy_type()` as the GDBusProxyTypeFunc. See `g_dbus_object_manager_client_new()` for more details.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_idle_dbus_object_manager_client_new_finish()` to get the result of the operation.

See `phosh_idle_dbus_object_manager_client_new_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusObjectManagerClientFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### phosh_idle_dbus_object_manager_client_new_finish ()

    GDBusObjectManager *
    phosh_idle_dbus_object_manager_client_new_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_idle_dbus_object_manager_client_new()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_idle_dbus_object_manager_client_new()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed object manager client or `NULL` if `error` is set.

[transfer full][type PhoshIdleDBusObjectManagerClient]

### phosh_idle_dbus_object_manager_client_new_sync ()

    GDBusObjectManager *
    phosh_idle_dbus_object_manager_client_new_sync
                                   (GDBusConnection *connection,
                                    GDBusObjectManagerClientFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously creates GDBusObjectManagerClient using `phosh_idle_dbus_object_manager_client_get_proxy_type()` as the GDBusProxyTypeFunc. See `g_dbus_object_manager_client_new_sync()` for more details.

The calling thread is blocked until a reply is received.

See `phosh_idle_dbus_object_manager_client_new()` for the asynchronous version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusObjectManagerClientFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed object manager client or `NULL` if `error` is set.

[transfer full][type PhoshIdleDBusObjectManagerClient]

### phosh_idle_dbus_object_manager_client_new_for_bus ()

    void
    phosh_idle_dbus_object_manager_client_new_for_bus
                                   (GBusType bus_type,
                                    GDBusObjectManagerClientFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Like `phosh_idle_dbus_object_manager_client_new()` but takes a GBusType instead of a GDBusConnection.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `phosh_idle_dbus_object_manager_client_new_for_bus_finish()` to get the result of the operation.

See `phosh_idle_dbus_object_manager_client_new_for_bus_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusObjectManagerClientFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### phosh_idle_dbus_object_manager_client_new_for_bus_finish ()

    GDBusObjectManager *
    phosh_idle_dbus_object_manager_client_new_for_bus_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `phosh_idle_dbus_object_manager_client_new_for_bus()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `phosh_idle_dbus_object_manager_client_new_for_bus()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed object manager client or `NULL` if `error` is set.

[transfer full][type PhoshIdleDBusObjectManagerClient]

### phosh_idle_dbus_object_manager_client_new_for_bus_sync ()

    GDBusObjectManager *
    phosh_idle_dbus_object_manager_client_new_for_bus_sync
                                   (GBusType bus_type,
                                    GDBusObjectManagerClientFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Like `phosh_idle_dbus_object_manager_client_new_sync()` but takes a GBusType instead of a GDBusConnection.

The calling thread is blocked until a reply is received.

See `phosh_idle_dbus_object_manager_client_new_for_bus()` for the asynchronous version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusObjectManagerClientFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed object manager client or `NULL` if `error` is set.

[transfer full][type PhoshIdleDBusObjectManagerClient]

## Types and Values

### struct PhoshIdleDBusIdleMonitorIface

    struct PhoshIdleDBusIdleMonitorIface {
      GTypeInterface parent_iface;

      gboolean (*handle_add_idle_watch) (
        PhoshIdleDBusIdleMonitor *object,
        GDBusMethodInvocation *invocation,
        guint64 arg_interval);

      gboolean (*handle_add_user_active_watch) (
        PhoshIdleDBusIdleMonitor *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_get_idletime) (
        PhoshIdleDBusIdleMonitor *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_remove_watch) (
        PhoshIdleDBusIdleMonitor *object,
        GDBusMethodInvocation *invocation,
        guint arg_id);

      void (*watch_fired) (
        PhoshIdleDBusIdleMonitor *object,
        guint arg_id);
    };

Virtual table for the D-Bus interface org.gnome.Mutter.IdleMonitor.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_add_idle_watch` () | Handler for the “handle-add-idle-watch” signal. |
`handle_add_user_active_watch` () | Handler for the “handle-add-user-active-watch” signal. |
`handle_get_idletime` () | Handler for the “handle-get-idletime” signal. |
`handle_remove_watch` () | Handler for the “handle-remove-watch” signal. |
`watch_fired` () | Handler for the “watch-fired” signal. |

### struct PhoshIdleDBusIdleMonitorProxy

    struct PhoshIdleDBusIdleMonitorProxy;

The PhoshIdleDBusIdleMonitorProxy structure contains only private data and should only be accessed using the provided API.

### struct PhoshIdleDBusIdleMonitorProxyClass

    struct PhoshIdleDBusIdleMonitorProxyClass {
      GDBusProxyClass parent_class;
    };

Class structure for PhoshIdleDBusIdleMonitorProxy.

#### Members

### struct PhoshIdleDBusIdleMonitorSkeleton

    struct PhoshIdleDBusIdleMonitorSkeleton;

The PhoshIdleDBusIdleMonitorSkeleton structure contains only private data and should only be accessed using the provided API.

### struct PhoshIdleDBusIdleMonitorSkeletonClass

    struct PhoshIdleDBusIdleMonitorSkeletonClass {
      GDBusInterfaceSkeletonClass parent_class;
    };

Class structure for PhoshIdleDBusIdleMonitorSkeleton.

#### Members

### struct PhoshIdleDBusObjectIface

    struct PhoshIdleDBusObjectIface {
      GTypeInterface parent_iface;
    };

Virtual table for the PhoshIdleDBusObject interface.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |

### struct PhoshIdleDBusObjectProxy

    struct PhoshIdleDBusObjectProxy;

The PhoshIdleDBusObjectProxy structure contains only private data and should only be accessed using the provided API.

### struct PhoshIdleDBusObjectProxyClass

    struct PhoshIdleDBusObjectProxyClass {
      GDBusObjectProxyClass parent_class;
    };

Class structure for PhoshIdleDBusObjectProxy.

#### Members

### struct PhoshIdleDBusObjectSkeleton

    struct PhoshIdleDBusObjectSkeleton;

The PhoshIdleDBusObjectSkeleton structure contains only private data and should only be accessed using the provided API.

### struct PhoshIdleDBusObjectSkeletonClass

    struct PhoshIdleDBusObjectSkeletonClass {
      GDBusObjectSkeletonClass parent_class;
    };

Class structure for PhoshIdleDBusObjectSkeleton.

#### Members

### struct PhoshIdleDBusObjectManagerClient

    struct PhoshIdleDBusObjectManagerClient;

The PhoshIdleDBusObjectManagerClient structure contains only private data and should only be accessed using the provided API.

### struct PhoshIdleDBusObjectManagerClientClass

    struct PhoshIdleDBusObjectManagerClientClass {
      GDBusObjectManagerClientClass parent_class;
    };

Class structure for PhoshIdleDBusObjectManagerClient.

#### Members

### PhoshIdleDBusIdleMonitor

    typedef struct _PhoshIdleDBusIdleMonitor PhoshIdleDBusIdleMonitor;

Abstract interface type for the D-Bus interface org.gnome.Mutter.IdleMonitor.

### PhoshIdleDBusIdleMonitorProxyPrivate

    typedef struct _PhoshIdleDBusIdleMonitorProxyPrivate PhoshIdleDBusIdleMonitorProxyPrivate;

### PhoshIdleDBusIdleMonitorSkeletonPrivate

    typedef struct _PhoshIdleDBusIdleMonitorSkeletonPrivate PhoshIdleDBusIdleMonitorSkeletonPrivate;

### PhoshIdleDBusObject

    typedef struct _PhoshIdleDBusObject PhoshIdleDBusObject;

The PhoshIdleDBusObject type is a specialized container of interfaces.

### PhoshIdleDBusObjectManagerClientPrivate

    typedef struct _PhoshIdleDBusObjectManagerClientPrivate PhoshIdleDBusObjectManagerClientPrivate;

### PhoshIdleDBusObjectProxyPrivate

    typedef struct _PhoshIdleDBusObjectProxyPrivate PhoshIdleDBusObjectProxyPrivate;

### PhoshIdleDBusObjectSkeletonPrivate

    typedef struct _PhoshIdleDBusObjectSkeletonPrivate PhoshIdleDBusObjectSkeletonPrivate;

## Property Details

### The `“idle-monitor”` property

      “idle-monitor”             PhoshIdleDBusIdleMonitor *

The PhoshIdleDBusIdleMonitor instance corresponding to the D-Bus interface org.gnome.Mutter.IdleMonitor, if any.

Connect to the “notify” signal to get informed of property changes.

Owner: PhoshIdleDBusObject

Flags: Read / Write

## Signal Details

### The `“handle-add-idle-watch”` signal

    gboolean
    user_function (PhoshIdleDBusIdleMonitor *object,
                   GDBusMethodInvocation    *invocation,
                   guint64                   arg_interval,
                   gpointer                  user_data)

Signal emitted when a remote caller is invoking the `AddIdleWatch()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `phosh_idle_dbus_idle_monitor_complete_add_idle_watch()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A PhoshIdleDBusIdleMonitor. |
invocation | A GDBusMethodInvocation. |
arg_interval | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-add-user-active-watch”` signal

    gboolean
    user_function (PhoshIdleDBusIdleMonitor *object,
                   GDBusMethodInvocation    *invocation,
                   gpointer                  user_data)

Signal emitted when a remote caller is invoking the `AddUserActiveWatch()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `phosh_idle_dbus_idle_monitor_complete_add_user_active_watch()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A PhoshIdleDBusIdleMonitor. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-get-idletime”` signal

    gboolean
    user_function (PhoshIdleDBusIdleMonitor *object,
                   GDBusMethodInvocation    *invocation,
                   gpointer                  user_data)

Signal emitted when a remote caller is invoking the `GetIdletime()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `phosh_idle_dbus_idle_monitor_complete_get_idletime()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A PhoshIdleDBusIdleMonitor. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-remove-watch”` signal

    gboolean
    user_function (PhoshIdleDBusIdleMonitor *object,
                   GDBusMethodInvocation    *invocation,
                   guint                     arg_id,
                   gpointer                  user_data)

Signal emitted when a remote caller is invoking the `RemoveWatch()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `phosh_idle_dbus_idle_monitor_complete_remove_watch()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A PhoshIdleDBusIdleMonitor. |
invocation | A GDBusMethodInvocation. |
arg_id | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“watch-fired”` signal

    void
    user_function (PhoshIdleDBusIdleMonitor *object,
                   guint                     arg_id,
                   gpointer                  user_data)

On the client-side, this signal is emitted whenever the D-Bus signal "WatchFired" is received.

On the service-side, this signal can be used with e.g. `g_signal_emit_by_name()` to make the object emit the D-Bus signal.

#### Parameters

object | A PhoshIdleDBusIdleMonitor. |
arg_id | Argument. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last